| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::GLSLESProgramPipeline Class Reference

Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for OpenGL ES 2.0. More...

`#include <OgreGLSLESProgramPipeline.h>`

Inheritance diagram for Ogre::GLSLESProgramPipeline:
[legend]

## Public Member Functions
| GLSLESProgramPipeline (GLSLESProgram *vertexProgram, GLSLESProgram *fragmentProgram)
| Constructor should only be used by GLSLESProgramPipelineManager. More...
virtual | ~GLSLESProgramPipeline ()
void | activate (void)
| Makes a program pipeline object active by making sure it is linked and then putting it in use. More...
void | bindFixedAttributes (GLuint program)
void | extractLayoutQualifiers (void)
GLSLESProgram * | getFragmentProgram (void) const
uint | getGLProgramHandle (void) const
| Get the GL Handle for the program object. More...
GLSLESProgram * | getVertexProgram (void) const
bool | isSkeletalAnimationIncluded (void) const
| Returns whether the linked program includes the required instructions to perform skeletal animation. More...
bool | isUsingShader (GLSLShaderCommon *shader) const
| query if the program is using the given shader More...
void | setSkeletalAnimationIncluded (bool included)
| Sets whether the linked program includes the required instructions to perform skeletal animation. More...
virtual void | updatePassIterationUniforms (GpuProgramParametersSharedPtr params)
| Updates program pipeline object uniforms using data from pass iteration GpuProgramParameters. More...
virtual void | updateUniformBlocks (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)
| Updates program object uniform blocks using data from GpuProgramParameters. More...
virtual void | updateUniforms (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)
| Updates program pipeline object uniforms using data from GpuProgramParameters. More...

## Static Public Member Functions
static int32 | getFixedAttributeIndex (VertexElementSemantic semantic, uint index)
| Get the fixed attribute bindings normally used by GL for a semantic. More...
static void | useTightAttributeLayout ()
| use alternate vertex attribute layout using only 8 vertex attributes More...

## Detailed Description

Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for OpenGL ES 2.0.

Remarks
  GLSL ES has no target assembler or entry point specification like DirectX 9 HLSL. Vertex and Fragment shaders only have one entry point called "main".
  When a shader is compiled, microcode is generated but can not be accessed by the application. GLSL ES also does not provide assembler low level output after compiling. The GL ES Render system assumes that the Gpu program is a GL Gpu program so GLSLESProgramPipeline will create a GLSLESGpuProgram that is subclassed from GLES2GpuProgram for the low level implementation. The GLES2Program class will create a shader and program object and compile the source but will not create a pipeline object. It's up to GLES2GpuProgram class to request a program pipeline object to link the program object to.

Note
  GLSL ES supports multiple modular shader objects that can be attached to one program object to form a single shader. This is supported through the "attach" material script command. All the modules to be attached are listed on the same line as the attach command separated by white space.

## Constructor & Destructor Documentation

## ◆ GLSLESProgramPipeline()

Ogre::GLSLESProgramPipeline::GLSLESProgramPipeline | ( | GLSLESProgram * | vertexProgram,
|  | GLSLESProgram * | fragmentProgram
| ) |  |

Constructor should only be used by GLSLESProgramPipelineManager.

## ◆ ~GLSLESProgramPipeline()

virtual Ogre::GLSLESProgramPipeline::~GLSLESProgramPipeline | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ updateUniforms()

virtual void Ogre::GLSLESProgramPipeline::updateUniforms | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| virtual

Updates program pipeline object uniforms using data from GpuProgramParameters.

normally called by GLSLESGpuProgram::bindParameters() just before rendering occurs.

Implements Ogre::GLSLProgramCommon.

## ◆ updateUniformBlocks()

virtual void Ogre::GLSLESProgramPipeline::updateUniformBlocks | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| virtual

Updates program object uniform blocks using data from GpuProgramParameters.

normally called by GLSLGpuProgram::bindParameters() just before rendering occurs.

Implements Ogre::GLSLProgramCommon.

## ◆ updatePassIterationUniforms()

virtual void Ogre::GLSLESProgramPipeline::updatePassIterationUniforms | ( | GpuProgramParametersSharedPtr | params | ) |
| virtual

Updates program pipeline object uniforms using data from pass iteration GpuProgramParameters.

normally called by GLSLESGpuProgram::bindMultiPassParameters() just before multi pass rendering occurs.

Implements Ogre::GLSLProgramCommon.

## ◆ activate()

void Ogre::GLSLESProgramPipeline::activate | ( | void |  | ) |
| virtual

Makes a program pipeline object active by making sure it is linked and then putting it in use.

Implements Ogre::GLSLProgramCommon.

## ◆ bindFixedAttributes()

void Ogre::GLSLESProgramCommon::bindFixedAttributes | ( | GLuint | program | ) |
| inherited

## ◆ getVertexProgram()

GLSLESProgram* Ogre::GLSLESProgramCommon::getVertexProgram | ( | void |  | ) | const
| inline inherited

## ◆ getFragmentProgram()

GLSLESProgram* Ogre::GLSLESProgramCommon::getFragmentProgram | ( | void |  | ) | const
| inline inherited

## ◆ isUsingShader()

bool Ogre::GLSLESProgramCommon::isUsingShader | ( | GLSLShaderCommon * | shader | ) | const
| inline virtual inherited

query if the program is using the given shader

Implements Ogre::GLSLProgramCommon.

## ◆ extractLayoutQualifiers()

void Ogre::GLSLProgramCommon::extractLayoutQualifiers | ( | void |  | ) |
| inherited

## ◆ setSkeletalAnimationIncluded()

void Ogre::GLSLProgramCommon::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inline inherited

Sets whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ isSkeletalAnimationIncluded()

bool Ogre::GLSLProgramCommon::isSkeletalAnimationIncluded | ( | void |  | ) | const
| inline inherited

Returns whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ getGLProgramHandle()

uint Ogre::GLSLProgramCommon::getGLProgramHandle | ( | void |  | ) | const
| inline inherited

Get the GL Handle for the program object.

## ◆ getFixedAttributeIndex()

static int32 Ogre::GLSLProgramCommon::getFixedAttributeIndex | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |
| static inherited

Get the fixed attribute bindings normally used by GL for a semantic.

## ◆ useTightAttributeLayout()

static void Ogre::GLSLProgramCommon::useTightAttributeLayout | ( |  | ) |
| static inherited

use alternate vertex attribute layout using only 8 vertex attributes

For "Vivante GC1000" and "VideoCore IV" (notably in Raspberry Pi) on GLES2

The documentation for this class was generated from the following file:

- OgreGLSLESProgramPipeline.h